function points = clusteringTendency(coords, numTests)
% describe what this function does
% (hint: saying "it calculates the clustering tendency of a dataset" is not enough :-))
% (note: returning points, the random dataset generated last, is of no use 
% except for the didactical one, i.e. showing how a "bad" random dataset looks like)

    if nargin<2
        numTests = 1000;
    end
    
    % calculate euclidean distances between all points
    d = L2_distance(coords',coords');
    % sort distances (i_ will contain the distances ordered by nearest neighbors)
    [i_,~] = sort(d,2);
    i_=i_(:,1:10);
    sse_=sum(sum(i_.^2));

    % calculate the coords range from the data (ceil is not essential but
    % yields better results if comparing with numbers generated with rand()
    % in the 0~1 interval)
    coordsRange = ceil(max(coords)-min(coords));

    for i = 1 : numTests
        % generate numPts random points. The coordinates will have the same
        % range as the original data 
        points = rand(size(coords));
        points = bsxfun(@times, points, coordsRange);
        d = L2_distance(points',points');
        [i_,~]=sort(d,2);
        i_=i_(:,1:10);
        sse(i)=sum(sum(i_.^2));
    end

    figure;hist(sse);
    title(sprintf('Histogram showing [xxx] over %d runs (compare with calculated [xxx] of %.2e)',numTests,sse_));
    drawnow();
end