function [bestLabels,bestCentroids,bestSSE] = repKmeans(X,clusters,nIter)
% repeats k-means execution nIter times and returns the
% results which provide the lowest SSE across all iterations

if nargin < 3
	nIter = 10;
end

bestLabels = [];
bestCentroids = [];

% run kmeans nIter times
for i = 1 : nIter
        [centroids, ~, labels]= myKmeans(X, clusters);
        sse = SSE(X,centroids,labels);
        % fprintf('Execution %02d: SSE=%.6f\n',i,sse);
        if ((i==1) || (sse < bestSSE))
                bestSSE = sse;
                bestLabels = labels;
		bestCentroids = centroids;
        end
end

end
